<?php
###################################################################
#                                                                 #
# Produktname: One-Men-Statistik                                  #
#              =============                                      #
# Copyright (c) 2002 Steffen Sauer(steffen.sauer@akasu.de)        #
# http://codebase.akasu.de                                        #
#                                                                 #
# Dieses Produkt ist fr nichtkommerzielle Zwecke (Projekte)      #
# frei verwendbar, solange diese nicht gegen Menschenrechte       #
# verstoen oder auf solche Inhalte verlinken,                    #
# menschenverachtende Inhalte anbieten, zu Gewalthandlungen       #
# aufrufen oder diese gutheien oder auf solche verlinken.        #
#                                                                 #
# Modifikationen drfen am Programm vorgenommen werden, mssen    #
# aber an den Copyright-Inhaber(siehe oben) gemeldet werden.      #
#                                                                 #
# Dieser Hinweis muss innerhalb der Datei verbleiben.             #
# Eine Entfernung dieses Hinweises fhrt zu einer Aberkennung     #
# der freien Verwendbarkeit.                                      #
###################################################################

function menu()
{
if (file_exists("counter.dts"))
	{
	$fp = fopen("counter.dts","r");
	$c = fgets($fp,255);
	fclose($fp);
	$view = "Sie hatten bisher insgesamt $c Seitenzugriffe";
	}
else
	{
	$view = "Sie hatten bisher noch keine Seitenzugriffe";
	}
$now = time();
$yest = $now-86400;
$yest2 = $yest-86400;
$yest_1 = date("Ymd",$yest);
$yest_2 = date("Ymd",$yest2);
if(file_exists("files/$yest_1.db"))
	{
	$fp = file("files/$yest_1.db");
	$c = count($fp);
	$oldview.="<a href='stats.php?op=old_stats&f=$yest_1'>Gestern gab es $c Seitenzugriffe</a>&nbsp;&nbsp;&nbsp;-";
	}
if(file_exists("files/$yest_2.db"))
	{
	$fp = file("files/$yest_2.db");
	$c = count($fp);
	$oldview.="<a href='stats.php?op=old_stats&f=$yest_2'>Vorgestern gab es $c Seitenzugriffe</a>";
	}

echo "$oldview<br />";
echo "<b>$view</b><br /><a href='stats.php'>Hauptansicht</a> - <a href='stats.php?op=referer'>Heutige Referer</a> - <a href='stats.php?op=sideview'>Nach Seite sortiert</a> - <a href='stats.php?op=old_files'>Alte Logfiles</a> - <a href='stats.php?op=browser'>Browser</a> - <a href='stats.php?op=ip'>IP-Adressen</a></div><br>";
}

function oldmenu($f)
{
$f1 = substr($f,0,4);
$f2 = substr($f,4,-2);
$f3 = substr($f,6);
echo "<a href='stats.php'>Hauptansicht heutiger Tag</a><br /><b>Ansicht fr $f3.$f2.$f1</b><br /><a href='stats.php?op=old_stats&f=$f'>Hauptansicht</a> - <a href='stats.php?op=old_referer&f=$f'>Referer</a> - <a href='stats.php?op=old_sideview&f=$f'>Nach Seite sortiert</a> - <a href='stats.php?op=old_browser&f=$f'>Browser</a> - <a href='stats.php?op=old_ip&f=$f'>IP-Adressen</a> - <a href='stats.php?op=old_files'>Weitere Alte Logfiles</a></div><br>";
}

function main()
{
global $lim;
include ("design.php");
head();
$date = date("Ymd");
if(file_exists("files/$date.db"))
	{
	$fp = file("files/$date.db");
	$count = count($fp);
	echo "Bisher gab es <b>$count</b> Seitenaufrufe!<div align=center>";
	menu();
	$sites = $count / '20';
	$exist = substr_count($sites,".");
	if($exist == '1')
		{
		$sites = explode(".",$sites);
		$sites = $sites[0] + '1';
		}
	$m=1;

	for($ii=0;$ii<$sites;$ii++)
		{
		if($m == '1')
			{
			$limit='0';
			}
		else
			{
			$limit=($ii * '20');
			}
		$site.= " <a href='stats.php?lim=$limit'>$m</a> ";
		$m++;
		}
	echo "Seite: [ $site ]<br><br>";

	echo "<table border=1>";
	echo "<COLGROUP>";
	echo "<col bgcolor='#999999'></col><col bgcolor='#CCCCCC'></col><col bgcolor='#999999'></col><col bgcolor='#CCCCCC'></col><col bgcolor='#999999'></col><col bgcolor='#CCCCCC'></col>";
	echo "</COLGROUP>";
	echo "<tr><th>Uhrzeit</th><th>Besuchte Seite</th><th>Datei</th><th>IP-Nummer</th><th>Host</th><th>Browser</th></tr>";
	if(!isset($lim))$lim='0';
	$limits = $lim;
	$count2 = ($count-$limits-'20');
	if($count2 < '0')$count2 = '-1';
	$n='0';

	for($i=($count-$limits);$i>$count2;$i--)
		{
		$array[] = $fp[$i];
		$stat = $array[$n];
		$stat = explode(";",$stat);
		$stat1 = substr($stat[1],0,35);
		$stat2 = substr($stat[2],0,35);
		if(!empty($stat[0]))
			{
			echo "<tr><td><b>$stat[0]&nbsp;</b></td><td>$stat1&nbsp;</td><td>$stat2&nbsp;</td><td>$stat[3]&nbsp;</td><td>$stat[4]&nbsp;</td><td>$stat[5]&nbsp;</td></tr>";
			}
		$n++;
		}
	echo "</table>";
	echo "<br>Seite: [ $site ]<br>";
	}
else
	{
	menu();
	echo "Ihre Internetseite wurde heute noch nicht besucht";
	}
foot();
}

function referer($f)
{
include "globals.php";
include ("design.php");

head();

$date = date("Ymd");

if(file_exists("files/$date.db"))
	{
	$fp = file("files/$date.db");
	$count = count($fp);
	echo "Bisher gab es <b>$count</b> Seitenabrufe!<div align='center'>";
	menu();
	echo "<table width='95%' align='center'><tr><td>";
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$out = $array[$i];
		$out = explode(";",$out);
		$out1 = $out[1];
		if(!eregi($root,$out1))
			{
			if(!empty($out1))
				{
				$referer[] = $out1;
				}
			else
				{
				continue;
				}
			}
		else
			{
			continue;
			}
		}
	$count = count($referer);
	$referer2 = array_unique($referer);
	$count2 = count($referer2);
	sort($referer2);
	if($count > '0')
		{
		sort($referer);
		echo "Es gibt $count2 Refererer<br><br>";
		while(list($key,$value) = each($referer2))
			{
			$m=0;
			$query=md5($value);
			for($i=0;$i<$count;$i++)
				{
				$data = $referer[$i];
				$data = md5($data);
				if(!eregi("$query","$data"))
					{
					echo "";
					}
				else
					{
					$m++;
					}
				}
			echo "$m mal - <a href='$value' target='blank'>$value</a><br>";
			}
		}
	}
else
	{
	menu();
	}
echo "</td></tr></table>";
foot();
}


function sideview()
{
include "globals.php";
include ("design.php");
head();
$date = date("Ymd");
if(file_exists("files/$date.db"))
	{
	$fp = file("files/$date.db");
	$count = count($fp);
	echo "Bisher gab es <b>$count</b> Seitenabrufe!<div align='center'>";
	menu();
	echo "<table width='95%' align='center'><tr><td>";
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$out = $array[$i];
		$out = explode(";",$out);
		$out1 = $out[2];
		$out1 = str_replace("/","",$out1);
		$c = strpos($out1,"?");
		if($c != 0):$out1=substr($out1,0,$c);endif;
		$referer[] = $out1;
		}
	$referer2 = array_unique($referer);
	$count2 = count($referer2);
	if($count2 > '0')
		{
		sort($referer);
		sort($referer2);
		echo "Es wurden $count2 unterschiedliche Seiten abgerufen<br><br>";
		while(list($key,$value) = each($referer2))
			{
			$m=0;
			$query=md5($value);
			for($i=0;$i<$count;$i++)
				{
				$data = $referer[$i];
				$data = md5($data);
				if(!eregi("$query","$data"))
					{
					echo "";
					}
				else
					{
					$m++;
					}
				}
			echo "$m mal - $value<br>";
			}
		}
	}
else
	{
	menu();
	}
echo "</td></tr></table>";
foot();
}

function old_files()
{
include("design.php");
head();
menu();
$handle = opendir("files");
if($handle)
    {
     while ($file = readdir($handle))
        {
        if(($file != ".") && ($file != ".."))
            {
            $filelist[] = $file;
            }
        }
    closedir($handle);
    }

sort($filelist);
while(list($key,$value) = each ($filelist))
    {
    $value1 = substr($value,0,4);
    $value2 = substr($value,4,-5);
    $value3 = substr($value,6,-3);
    $value = explode(".",$value);
    echo "<a href='stats.php?op=old_stats&f=$value[0]'>$value3.$value2.$value1</a> - <a href='stats.php?op=old_referer&f=$value[0]'>Referer</a> -  <a href='stats.php?op=old_sideview&f=$value[0]'>Seiten geordnet</a> -  <a href='stats.php?op=old_browser&f=$value[0]'>Browser</a> - <a href='stats.php?op=old_ip&f=$value[0]'>IP-Adressen</a><br>";
    }
foot();
}

function old_stats($f)
{
global $lim,$f;
include ("design.php");
head();
oldmenu($f);
if(file_exists("files/$f.db"))
	{
	$fp = file("files/$f.db");
	$count = count($fp);
	$f1 = substr($f,0,4);
    $f2 = substr($f,4,-2);
    $f3 = substr($f,6);
    echo "Am $f3.$f2.$f1 gab es <b>$count</b> Seitenaufrufe!<div align=center>";
	$sites = $count / '20';
	$exist = substr_count($sites,".");
	if($exist == '1')
		{
		$sites = explode(".",$sites);
		$sites = $sites[0] + '1';
		}
	$m=1;
	for($ii=0;$ii<$sites;$ii++)
		{
		if($m == '1')
			{
			$limit='0';
			}
		else
			{
			$limit=($ii * '20');
			}
		$site.= " <a href='stats.php?op=old_stats&lim=$limit&f=$f'>$m</a> ";
		$m++;
		}
	echo "Seite: [ $site ]<br><br>";
	echo "<table border=1>";
	echo "<COLGROUP>";
	echo "<col bgcolor='#999999'></col><col bgcolor='#CCCCCC'></col><col bgcolor='#999999'></col><col bgcolor='#CCCCCC'></col><col bgcolor='#999999'></col><col bgcolor='#CCCCCC'></col>";
	echo "</COLGROUP>";
	echo "<tr><th>Uhrzeit</th><th>Besuchte Seite</th><th>Datei</th><th>IP-Nummer</th><th>Host</th><th>Browser</th></tr>";
	if(!isset($lim))$lim='0';
	$limits = $lim;
	$count2 = ($count-$limits-'20');
	if($count2 < '0')$count2 = '-1';
	$n='0';

	for($i=($count-$limits);$i>$count2;$i--)
		{
		$array[] = $fp[$i];
		$stat = $array[$n];
		$stat = explode(";",$stat);
		$stat1 = substr($stat[1],0,35);
		$stat2 = substr($stat[2],0,35);
		if(!empty($stat[0]))
			{
			echo "<tr><td><b>$stat[0]&nbsp;</b></td><td>$stat1&nbsp;</td><td>$stat2&nbsp;</td><td>$stat[3]&nbsp;</td><td>$stat[4]&nbsp;</td><td>$stat[5]&nbsp;</td></tr>";
			}
		$n++;
		}
	echo "</table>";
	echo "<br>Seite: [ $site ]<br>";
	}
else
	{
	echo "Ihre Internetseite wurde heute noch nicht besucht";
	}
foot();
}

function old_referer($f)
{
global $f;
include "globals.php";
include ("design.php");
head();
oldmenu($f);
if(file_exists("files/$f.db"))
	{
	$fp = file("files/$f.db");
	$count = count($fp);
	$f1 = substr($f,0,4);
    $f2 = substr($f,4,-2);
    $f3 = substr($f,6);
    echo "Am $f3.$f2.$f1 gab es <b>$count</b> Seitenabrufe!<div align='center'>";
	echo "<table width='95%' align='center'><tr><td>";
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$out = $array[$i];
		$out = explode(";",$out);
		$out1 = $out[1];
		if(!eregi($root,$out1))
			{
			if(!empty($out1))
				{
				$referer[] = $out1;
				}
			else
				{
				continue;
				}
			}
		else
			{
			continue;
			}
		}
	$count = count($referer);
	$referer2 = array_unique($referer);
	$count2 = count($referer2);
	sort($referer2);
	if($count > '0')
		{
		sort($referer);
		echo "Es gibt $count2 Refererer<br><br>";
		while(list($key,$value) = each($referer2))
			{
			$m=0;
			$query=md5($value);
			for($i=0;$i<$count;$i++)
				{
				$data = $referer[$i];
				$data = md5($data);
				if(!eregi("$query","$data"))
					{
					echo "";
					}
				else
					{
					$m++;
					}
				}
			echo "$m mal - <a href='$value' target='blank'>$value</a><br>";
			}
		}
	}
echo "</td></tr></table>";
foot();
}

function old_sideview($f)
{
include "globals.php";
include ("design.php");
head();
oldmenu($f);
$date = date("Ymd");
if(file_exists("files/$f.db"))
	{
	$fp = file("files/$f.db");
	$count = count($fp);
	echo "An diesem Tag gab es <b>$count</b> Seitenabrufe!<div align='center'>";
	echo "<table width='95%' align='center'><tr><td>";
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$out = $array[$i];
		$out = explode(";",$out);
		$out1 = $out[2];
		$out1 = str_replace("/","",$out1);
		$c = strpos($out1,"?");
		if($c != 0):$out1=substr($out1,0,$c);endif;
		$referer[] = $out1;
		}
	$referer2 = array_unique($referer);
	$count2 = count($referer2);
	if($count2 > '0')
		{
		sort($referer);
		sort($referer2);
		echo "Es wurden $count2 unterschiedliche Seiten abgerufen<br><br>";
		while(list($key,$value) = each($referer2))
			{
			$m=0;
			$query=md5($value);
			for($i=0;$i<$count;$i++)
				{
				$data = $referer[$i];
				$data = md5($data);
				if(!eregi("$query","$data"))
					{
					echo "";
					}
				else
					{
					$m++;
					}
				}
			echo "$m mal - $value<br>";
			}
		}
	}
echo "</td></tr></table>";
foot();
}

function browser()
{
include "globals.php";
include ("design.php");
head();
menu();
$date = date("Ymd");
if(file_exists("files/$date.db"))
	{
	$fp = file("files/$date.db");
	$count = count($fp);
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$daten = $array[$i];
		$daten = explode(";",$daten);
		$browser[] = $daten[5];
		}
	$browser2 = array_unique($browser);
	echo "Browser<br /><br />";
	$count = count($browser);
	sort($browser);
	while(list($key,$value) = each($browser2))
		{
		$m=0;
		$query=md5($value);
		for($i=0;$i<$count;$i++)
			{
			$data = $browser[$i];
			$data = md5($data);
			if(!eregi("$query","$data"))
				{
				echo "";
				}
			else
				{
				$m++;
				}
			}
		echo "$m mal - $value<br>";
		}
	}
foot();
}

function ip()
{
include "globals.php";
include ("design.php");
head();
menu();
$date = date("Ymd");
if(file_exists("files/$date.db"))
	{
	$fp = file("files/$date.db");
	$count = count($fp);
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$daten = $array[$i];
		$daten = explode(";",$daten);
		$ip[] = $daten[4];
		}
	$ip2 = array_unique($ip);
	sort($ip2);
	$c = count($ip2);
	echo "Es sind $c unterschiedliche IP-Adressen verzeichnet<br /><br />";
	$count = count($ip);
	sort($ip);
	while(list($key,$value) = each($ip2))
		{
		$m=0;
		$query=md5($value);
		for($i=0;$i<$count;$i++)
			{
			$data = $ip[$i];
			$data = md5($data);
			if(!eregi("$query","$data"))
				{
				echo "";
				}
			else
				{
				$m++;
				}
			}
		echo "$m mal - $value<br>";
		}
	}
foot();
}

function old_browser($f)
{
include "globals.php";
include ("design.php");
head();
oldmenu($f);
$date = date("Ymd");
if(file_exists("files/$f.db"))
	{
	$fp = file("files/$f.db");
	$count = count($fp);
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$daten = $array[$i];
		$daten = explode(";",$daten);
		$browser[] = $daten[5];
		}
	$browser2 = array_unique($browser);
	echo "Browser<br /><br />";
	$count = count($browser);
	sort($browser);
	while(list($key,$value) = each($browser2))
		{
		$m=0;
		$query=md5($value);
		for($i=0;$i<$count;$i++)
			{
			$data = $browser[$i];
			$data = md5($data);
			if(!eregi("$query","$data"))
				{
				echo "";
				}
			else
				{
				$m++;
				}
			}
		echo "$m mal - $value<br>";
		}
	}
foot();
}

function old_ip($f)
{
include "globals.php";
include ("design.php");
head();
oldmenu($f);
$date = date("Ymd");
if(file_exists("files/$f.db"))
	{
	$fp = file("files/$f.db");
	$count = count($fp);
	for($i=0;$i<$count;$i++)
		{
		$array[] = $fp[$i];
		$daten = $array[$i];
		$daten = explode(";",$daten);
		$ip[] = $daten[4];
		}
	$ip2 = array_unique($ip);
	sort($ip2);
	$c = count($ip2);
	echo "Es sind $c unterschiedliche IP-Adressen verzeichnet<br /><br />";
	$count = count($ip);
	sort($ip);
	while(list($key,$value) = each($ip2))
		{
		$m=0;
		$query=md5($value);
		for($i=0;$i<$count;$i++)
			{
			$data = $ip[$i];
			$data = md5($data);
			if(!eregi("$query","$data"))
				{
				echo "";
				}
			else
				{
				$m++;
				}
			}
		echo "$m mal - $value<br>";
		}
	}
foot();
}



switch ($op)
	{
	case "referer":
		referer($f);
	break;

	case "sideview":
		sideview();
	break;

    case "old_files":
         old_files();
    break;

    case "old_stats":
         old_stats($f);
    break;

    case "old_referer":
         old_referer($f);
    break;

	case "old_sideview":
		old_sideview($f);
	break;

	case "browser":
		browser();
	break;

	case "ip":
		ip();
	break;

	case "old_browser":
		old_browser($f);
	break;

	case "old_ip":
		old_ip($f);
	break;

	default:
		main();
	break;
	}

?>